/* vinv.c */
/* Fortran interface file */

/*
* This file was generated automatically by bfort from the C source
* file.  
 */

#ifdef USE_POINTER_CONVERSION
#if defined(__cplusplus)
extern "C" { 
#endif 
extern void *PetscToPointer(void *);
extern int PetscFromPointer(void *);
extern void PetscRmPointer(void *);
#if defined(__cplusplus)
} 
#endif 

#else

#define PetscToPointer(a) (*(long *)(a))
#define PetscFromPointer(a) (long)(a)
#define PetscRmPointer(a)
#endif

#include "vec.h"
#ifdef MPI_BUILD_PROFILING
#ifdef HAVE_FORTRAN_CAPS
#define vecstridegather_ PVECSTRIDEGATHER
#elif !defined(HAVE_FORTRAN_UNDERSCORE) && !defined(FORTRANDOUBLEUNDERSCORE)
#define vecstridegather_ pvecstridegather
#else
#define vecstridegather_ pvecstridegather_
#endif
#else
#ifdef HAVE_FORTRAN_CAPS
#define vecstridegather_ VECSTRIDEGATHER
#elif !defined(HAVE_FORTRAN_UNDERSCORE) && !defined(FORTRANDOUBLEUNDERSCORE)
#define vecstridegather_ vecstridegather
#endif
#endif

#ifdef MPI_BUILD_PROFILING
#ifdef HAVE_FORTRAN_CAPS
#define vecstridescatter_ PVECSTRIDESCATTER
#elif !defined(HAVE_FORTRAN_UNDERSCORE) && !defined(FORTRANDOUBLEUNDERSCORE)
#define vecstridescatter_ pvecstridescatter
#else
#define vecstridescatter_ pvecstridescatter_
#endif
#else
#ifdef HAVE_FORTRAN_CAPS
#define vecstridescatter_ VECSTRIDESCATTER
#elif !defined(HAVE_FORTRAN_UNDERSCORE) && !defined(FORTRANDOUBLEUNDERSCORE)
#define vecstridescatter_ vecstridescatter
#endif
#endif

#ifdef MPI_BUILD_PROFILING
#ifdef HAVE_FORTRAN_CAPS
#define vecsum_ PVECSUM
#elif !defined(HAVE_FORTRAN_UNDERSCORE) && !defined(FORTRANDOUBLEUNDERSCORE)
#define vecsum_ pvecsum
#else
#define vecsum_ pvecsum_
#endif
#else
#ifdef HAVE_FORTRAN_CAPS
#define vecsum_ VECSUM
#elif !defined(HAVE_FORTRAN_UNDERSCORE) && !defined(FORTRANDOUBLEUNDERSCORE)
#define vecsum_ vecsum
#endif
#endif

#ifdef MPI_BUILD_PROFILING
#ifdef HAVE_FORTRAN_CAPS
#define vecshift_ PVECSHIFT
#elif !defined(HAVE_FORTRAN_UNDERSCORE) && !defined(FORTRANDOUBLEUNDERSCORE)
#define vecshift_ pvecshift
#else
#define vecshift_ pvecshift_
#endif
#else
#ifdef HAVE_FORTRAN_CAPS
#define vecshift_ VECSHIFT
#elif !defined(HAVE_FORTRAN_UNDERSCORE) && !defined(FORTRANDOUBLEUNDERSCORE)
#define vecshift_ vecshift
#endif
#endif

#ifdef MPI_BUILD_PROFILING
#ifdef HAVE_FORTRAN_CAPS
#define vecabs_ PVECABS
#elif !defined(HAVE_FORTRAN_UNDERSCORE) && !defined(FORTRANDOUBLEUNDERSCORE)
#define vecabs_ pvecabs
#else
#define vecabs_ pvecabs_
#endif
#else
#ifdef HAVE_FORTRAN_CAPS
#define vecabs_ VECABS
#elif !defined(HAVE_FORTRAN_UNDERSCORE) && !defined(FORTRANDOUBLEUNDERSCORE)
#define vecabs_ vecabs
#endif
#endif

#ifdef MPI_BUILD_PROFILING
#ifdef HAVE_FORTRAN_CAPS
#define vecequal_ PVECEQUAL
#elif !defined(HAVE_FORTRAN_UNDERSCORE) && !defined(FORTRANDOUBLEUNDERSCORE)
#define vecequal_ pvecequal
#else
#define vecequal_ pvecequal_
#endif
#else
#ifdef HAVE_FORTRAN_CAPS
#define vecequal_ VECEQUAL
#elif !defined(HAVE_FORTRAN_UNDERSCORE) && !defined(FORTRANDOUBLEUNDERSCORE)
#define vecequal_ vecequal
#endif
#endif



/* Definitions of Fortran Wrapper routines */
#if defined(__cplusplus)
extern "C" {
#endif
void vecstridegather_(Vec v,int *start,Vec s,InsertMode *addv, int *__ierr ){
*__ierr = VecStrideGather(
	(Vec)PetscToPointer( (v) ),*start,
	(Vec)PetscToPointer( (s) ),*addv);
}
void vecstridescatter_(Vec s,int *start,Vec v,InsertMode *addv, int *__ierr ){
*__ierr = VecStrideScatter(
	(Vec)PetscToPointer( (s) ),*start,
	(Vec)PetscToPointer( (v) ),*addv);
}
void vecsum_(Vec v,Scalar *sum, int *__ierr ){
*__ierr = VecSum(
	(Vec)PetscToPointer( (v) ),sum);
}
void vecshift_( Scalar *shift,Vec v, int *__ierr ){
*__ierr = VecShift(shift,
	(Vec)PetscToPointer( (v) ));
}
void vecabs_(Vec v, int *__ierr ){
*__ierr = VecAbs(
	(Vec)PetscToPointer( (v) ));
}
void vecequal_(Vec vec1,Vec vec2,PetscTruth *flg, int *__ierr ){
*__ierr = VecEqual(
	(Vec)PetscToPointer( (vec1) ),
	(Vec)PetscToPointer( (vec2) ),flg);
}
#if defined(__cplusplus)
}
#endif
