#ifdef PETSC_RCS_HEADER
static char vcid[] = "$Id: asciredstubs.c,v 1.6 1999/04/02 21:34:40 balay Exp $";
#endif

/*
  System function stubs, contributed by Darin Diachin - diachin@mcs.anl.gov

  This source file contains stubs for some system functions, which are
  not avilable on the ASCI Red machine. These stubs enable us to build
  Petsc executables. But if the code goes and requests these functions,
  then they will not work as the regular system functions do.
*/

#include "petsc.h"
#if defined (PARCH_ascired)
#include <sys/types.h>
#include <unistd.h>


EXTERN_C_BEGIN
int socket(int domain, int type, int protocol)
{
   puts("\nPOSSIBLE PROBLEM: entered socket, in petscStub.c\n");
   return 0;
}

struct hostent *gethostbyname(const char *name)
{
   puts("\nPOSSIBLE PROBLEM: entered gethostbyname, in petscStub.c\n");
   return 0;
}
EXTERN_C_END

int getpagesize(void)
{
   puts("\nPOSSIBLE PROBLEM: entered getpagesize, in asciredstub.c\n");
   return 0;
}


int *getpwuid(void)
{
   puts("\nPOSSIBLE PROBLEM: entered getpwuid, in asciredstub.c\n");
   return 0;
}

int setsockopt(int s, int level, int optname,
          const char *optval, int optlen)
{
   puts("\nPOSSIBLE PROBLEM: entered setsockopt, in asciredstub.c\n");
   return 0;
}

pid_t fork(void)
{
   pid_t stub=0;
   puts("\nPOSSIBLE PROBLEM: entered fork, in asciredstub.c\n");
   return stub;
}

pid_t getppid(void)
{
   pid_t stub=0;
   puts("\nPOSSIBLE PROBLEM: entered getppid, in asciredstub.c\n");
   return stub;
}


int execvp (const char *file, char *const argv[])
{
   puts("\nPOSSIBLE PROBLEM: entered execvp, in asciredstub.c\n");
   return 0;
}

FILE *popen(char *command,char *type)
{
  puts("\nPOSSIBLE PROBLEM: entered execvp, in asciredstub.c\n");
  return 0;
}

#else

int asciredstubs_dummy(void)
{
  return 0;
}
#endif
